Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 14733)
@@ -59,4 +59,8 @@
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.MainForm.WindowsForms-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Persistence-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Data.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Data.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Data.cs	(revision 14733)
@@ -2,7 +2,9 @@
   using System.Linq;
 
-  using HeuristicLab.Common;
-  using HeuristicLab.Core;
+  using Common;
+  using Core;
+  using Persistence.Default.CompositeSerializers.Storable;
 
+  [StorableClass]
   public class Data : NamedItem {
     public Data(double bestResult, double worstResult, int testCount, int trainingCount,
@@ -20,4 +22,7 @@
     }
 
+    [StorableConstructor]
+    public Data(bool deserializing) : base(deserializing) { }
+
     public Data(Data origin, Cloner cloner) : base(origin, cloner) {
       this.BestResult = origin.BestResult;
@@ -28,11 +33,19 @@
     }
 
+    [Storable]
     public readonly IExampleParser ExampleParser;
+    [Storable]
     public readonly Example[] Examples;
+    [Storable]
     public readonly int OriginalTestCount;
+    [Storable]
     public readonly int OriginalTrainingCount;
+    [Storable]
     public readonly double WorstResult;
+    [Storable]
     public readonly double BestResult;
+    [Storable]
     public readonly int InputArgumentCount;
+    [Storable]
     public readonly int OutputArgumentCount;
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Example.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Example.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Example.cs	(revision 14733)
@@ -2,5 +2,7 @@
 
   using HeuristicLab.Common;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
+  [StorableClass]
   public class Example : DeepCloneable {
     public Example() {
@@ -17,4 +19,7 @@
     }
 
+    [StorableConstructor]
+    public Example(bool deserializing) { }
+
     public void CopyTo(Example example) {
       example.InputArgs = this.InputArgs;
@@ -30,13 +35,20 @@
     }
 
+    [Storable]
     public string[] InputArgs { get; set; }
+    [Storable]
     public string[] OutputArgs { get; set; }
+    [Storable]
     public long[] InputInt { get; set; }
+    [Storable]
     public double[] InputFloat { get; set; }
+    [Storable]
     public bool[] InputBoolean { get; set; }
+    [Storable]
     public long[] OutputInt { get; set; }
+    [Storable]
     public double[] OutputFloat { get; set; }
+    [Storable]
     public bool[] OutputBoolean { get; set; }
-
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14733)
@@ -144,5 +144,5 @@
     <Compile Include="Push\Expressions\ShoveExpressions.cs" />
     <Compile Include="Push\Expressions\StackdepthExpressions.cs" />
-    <Compile Include="Push\Expressions\StatefullExpression.cs" />
+    <Compile Include="Push\Expressions\StatefulExpression.cs" />
     <Compile Include="Push\Expressions\StatelessExpression.cs" />
     <Compile Include="Push\Expressions\SwapExpressions.cs" />
@@ -151,11 +151,11 @@
     <Compile Include="Push\Generators\CodeGenerator.cs" />
     <Compile Include="Push\Generators\NameGenerator.cs" />
-    <Compile Include="Push\Interpreter\IPushGpInterpreter.cs" />
-    <Compile Include="Push\Configuration\IReadonlyPushGpConfiguration.cs" />
-    <Compile Include="Push\Interpreter\PooledPushGpInterpreter.cs" />
-    <Compile Include="Push\Configuration\PushGpConfiguration.cs" />
-    <Compile Include="Push\Interpreter\PushGPInterpreter.cs" />
-    <Compile Include="Push\Interpreter\PushGpInterpreterPool.cs" />
-    <Compile Include="Push\Parser\PushGPParser.cs" />
+    <Compile Include="Push\Interpreter\IPushInterpreter.cs" />
+    <Compile Include="Push\Configuration\IReadonlyPushConfiguration.cs" />
+    <Compile Include="Push\Interpreter\PooledPushInterpreter.cs" />
+    <Compile Include="Push\Configuration\PushConfiguration.cs" />
+    <Compile Include="Push\Interpreter\PushInterpreter.cs" />
+    <Compile Include="Push\Interpreter\PushInterpreterPool.cs" />
+    <Compile Include="Push\Parser\PushParser.cs" />
     <Compile Include="Push\Creator\IPushProgramCreator.cs" />
     <Compile Include="Push\Problem\PushEncoding.cs" />
@@ -166,5 +166,5 @@
     <Compile Include="Push\Problem\PushSolution.cs" />
     <Compile Include="Push\Stack\IStack.cs" />
-    <Compile Include="Push\Stack\PushGPStack.cs" />
+    <Compile Include="Push\Stack\PushStack.cs" />
     <Compile Include="Push\Stack\StackType.cs" />
     <Compile Include="Push\Views\ExpressionSelectionView.cs">
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/IPushProgramCreator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/IPushProgramCreator.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/IPushProgramCreator.cs	(revision 14733)
@@ -13,5 +13,5 @@
   public interface IPushProgramCreator : ISolutionCreator
   {
-    PushProgram CreateProgram(IRandom random, IReadonlyPushGpConfiguration config);
+    PushProgram CreateProgram(IRandom random, IReadonlyPushConfiguration config);
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/PointsBasedPushProgramCreator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/PointsBasedPushProgramCreator.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/PointsBasedPushProgramCreator.cs	(revision 14733)
@@ -23,5 +23,5 @@
     }
 
-    public PushProgram CreateProgram(IRandom random, IReadonlyPushGpConfiguration config) {
+    public PushProgram CreateProgram(IRandom random, IReadonlyPushConfiguration config) {
       return CodeGenerator.RandomProgram(10, random, config);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs	(revision 14733)
@@ -9,5 +9,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.AND")]
   public class BooleanAndExpression : PushResultExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.BooleanStack, 2, values => values[0] && values[1]);
     }
@@ -19,5 +19,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.OR")]
   public class BooleanOrExpression : PushResultExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.BooleanStack, 2, values => values[0] || values[1]);
     }
@@ -29,5 +29,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.NOT")]
   public class BooleanNotExpression : PushResultExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.BooleanStack, 1, values => !values[0]);
     }
@@ -39,5 +39,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.FROMFLOAT")]
   public class BooleanFromFloatExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.FloatStack.Count == 0) return;
 
@@ -53,5 +53,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.FROMINTEGER")]
   public class BooleanFromIntegerExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.IntegerStack.Count == 0) return;
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 14733)
@@ -22,5 +22,5 @@
   [PushExpression(StackType.Code, "CODE.DO")]
   public class CodeDoExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
       if (interpreter.CodeStack.Count == 0) return;
@@ -36,5 +36,5 @@
   [PushExpression(StackType.Code, "CODE.DO*")]
   public class CodeDoXExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
       if (interpreter.CodeStack.Count == 0) return;
@@ -50,5 +50,5 @@
   [PushExpression(StackType.Code, "CODE.NOOP")]
   public class CodeNoopExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       // nothing to do
     }
@@ -61,5 +61,5 @@
   [PushExpression(StackType.Code, "CODE.QUOTE")]
   public class CodeQuoteExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
       if (interpreter.ExecStack.Count == 0) return;
@@ -77,5 +77,5 @@
   [PushExpression(StackType.Code, "CODE.IF")]
   public class CodeIfExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
       if ((interpreter.BooleanStack.Count == 0) || (interpreter.CodeStack.Count < 2)) return;
@@ -94,5 +94,5 @@
   [PushExpression(StackType.Code, "CODE.APPEND")]
   public class CodeAppendExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count < 2) return;
 
@@ -163,5 +163,5 @@
   [PushExpression(StackType.Code, "CODE.ATOM")]
   public class CodeAtomExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count == 0) return;
 
@@ -181,5 +181,5 @@
   [PushExpression(StackType.Code, "CODE.CAR")]
   public class CodeCarExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if ((interpreter.CodeStack.Count == 0) || (interpreter.CodeStack.Top.GetType() !=
                                                  typeof(ExecExpandExpression))) return;
@@ -202,5 +202,5 @@
   [PushExpression(StackType.Code, "CODE.CDR")]
   public class CodeCdrExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count == 0) return;
 
@@ -233,5 +233,5 @@
   [PushExpression(StackType.Code, "CODE.CONS")]
   public class CodeConsExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count < 2)
         return;
@@ -269,5 +269,5 @@
   [PushExpression(StackType.Code, "CODE.CONTAINER")]
   public class CodeContainerExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if ((interpreter.CodeStack.Count < 2) ||
           (interpreter.CodeStack[interpreter.CodeStack.Count - 2].GetType() !=
@@ -307,5 +307,5 @@
   [PushExpression(StackType.Code, "CODE.CONTAINS")]
   public class CodeContainsExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count < 2 ||
          !interpreter.CodeStack[interpreter.CodeStack.Count - 2].CanExpand)
@@ -327,5 +327,5 @@
   [PushExpression(StackType.Code, "CODE.DEFINITION")]
   public class CodeDefinitionExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if ((interpreter.NameStack.Count == 0) ||
           !interpreter.CustomExpressions.ContainsKey(interpreter.NameStack.Top)) return;
@@ -363,5 +363,5 @@
   [PushExpression(StackType.Code, "CODE.DISCREPANCY")]
   public class CodeDiscrepancyExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count < 2) return;
 
@@ -418,5 +418,5 @@
   [PushExpression(StackType.Code, "CODE.EXTRACT")]
   public class CodeExtractExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.IntegerStack.Count == 0 ||
           interpreter.CodeStack.Count == 0 ||
@@ -437,5 +437,5 @@
   [PushExpression(StackType.Code, "CODE.FROMBOOLEAN")]
   public class CodeFromBooleanExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.BooleanStack.Count == 0) return;
 
@@ -452,5 +452,5 @@
   [PushExpression(StackType.Code, "CODE.FROMFLOAT")]
   public class CodeFromFloatExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.FloatStack.Count == 0) return;
 
@@ -467,5 +467,5 @@
   [PushExpression(StackType.Code, "CODE.FROMINTEGER")]
   public class CodeFromIntegerExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.IntegerStack.Count == 0) return;
 
@@ -482,5 +482,5 @@
   [PushExpression(StackType.Code, "CODE.FROMNAME")]
   public class CodeFromNameExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.NameStack.Count == 0) return;
 
@@ -498,5 +498,5 @@
   [PushExpression(StackType.Code, "CODE.CODEINSERT")]
   public class CodeInsertExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.IntegerStack.Count == 0 ||
           interpreter.CodeStack.Count < 2 ||
@@ -533,5 +533,5 @@
   [PushExpression(StackType.Code, "CODE.LENGTH")]
   public class CodeLengthExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count == 0) return;
 
@@ -551,5 +551,5 @@
   [PushExpression(StackType.Code, "CODE.LIST")]
   public class CodeListExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count < 2) return;
 
@@ -568,5 +568,5 @@
   [PushExpression(StackType.Code, "CODE.MEMBER")]
   public class CodeMemberExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count < 2) return;
 
@@ -588,5 +588,5 @@
   [PushExpression(StackType.Code, "CODE.NTH")]
   public class CodeNthExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if ((interpreter.CodeStack.Count == 0) || (interpreter.IntegerStack.Count == 0)) return;
 
@@ -625,5 +625,5 @@
   [PushExpression(StackType.Code, "CODE.NTHCDR")]
   public class CodeNthCdrExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if ((interpreter.CodeStack.Count == 0) || (interpreter.IntegerStack.Count == 0)) return;
 
@@ -656,5 +656,5 @@
   [PushExpression(StackType.Code, "CODE.NULL")]
   public class CodeNullExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count == 0) return;
 
@@ -671,5 +671,5 @@
   [PushExpression(StackType.Code, "CODE.POSITION")]
   public class CodePositionExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count < 2) return;
 
@@ -697,5 +697,5 @@
   [PushExpression(StackType.Code, "CODE.SIZE")]
   public class CodeSizeExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count == 0) return;
 
@@ -717,5 +717,5 @@
   [PushExpression(StackType.Code, "CODE.SUBST")]
   public class CodeSubstitutionExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if ((interpreter.CodeStack.Count < 3) || (interpreter.CodeStack.Top.GetType() !=
                                                 typeof(ExecExpandExpression))) return;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 14733)
@@ -31,5 +31,5 @@
   [PushExpression(StackType.Code, "CODE.DEFINE")]
   public class CodeDefineExpression : DefineExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.Configuration.TopLevelPushCode && (interpreter.CodeStack.Count < 2)) return;
 
@@ -46,5 +46,5 @@
   [PushExpression(StackType.Exec, "EXEC.DEFINE")]
   public class ExecDefineExpression : DefineExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.ExecStack.Count < 2) return;
 
@@ -62,5 +62,5 @@
   public class FloatDefineExpression : DefineExpression<double> {
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(
         interpreter.FloatStack,
@@ -73,5 +73,5 @@
   [PushExpression(StackType.Integer, "INTEGER.DEFINE")]
   public class IntegerDefineExpression : DefineExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(
         interpreter.IntegerStack,
@@ -84,5 +84,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.DEFINE")]
   public class BooleanDefineExpression : DefineExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(
         interpreter.BooleanStack,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 14733)
@@ -8,5 +8,5 @@
     protected DoCountExpression() { }
     protected DoCountExpression(LoopState state) : base(state) { }
-    protected override bool HasInsufficientArguments(IPushGpInterpreter interpreter, IStack<Expression> sourceStack) {
+    protected override bool HasInsufficientArguments(IPushInterpreter interpreter, IStack<Expression> sourceStack) {
       return interpreter.IntegerStack.Count < 1 ||
              sourceStack.Count == 0 ||
@@ -14,5 +14,5 @@
     }
 
-    protected override LoopState InitState(IPushGpInterpreter interpreter, IStack<Expression> sourceStack) {
+    protected override LoopState InitState(IPushInterpreter interpreter, IStack<Expression> sourceStack) {
       var state = new LoopState(
         body: sourceStack.Pop(),
@@ -47,5 +47,5 @@
     public CodeDoCountExpression(LoopState state) : base(state) { }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter, interpreter.CodeStack);
     }
@@ -75,5 +75,5 @@
     public ExecDoCountExpression(LoopState state) : base(state) { }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter, interpreter.ExecStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 14733)
@@ -7,5 +7,5 @@
     protected DoRangeExpression() { }
     protected DoRangeExpression(LoopState state) : base(state) { }
-    protected override bool HasInsufficientArguments(IPushGpInterpreter interpreter, IStack<Expression> sourceStack) {
+    protected override bool HasInsufficientArguments(IPushInterpreter interpreter, IStack<Expression> sourceStack) {
       return interpreter.IntegerStack.Count < 2 ||
              sourceStack.Count == 0 ||
@@ -13,5 +13,5 @@
     }
 
-    protected override LoopState InitState(IPushGpInterpreter interpreter, IStack<Expression> sourceStack) {
+    protected override LoopState InitState(IPushInterpreter interpreter, IStack<Expression> sourceStack) {
       var destinationIndex = interpreter.IntegerStack.Pop();
       var incrementor = destinationIndex < interpreter.IntegerStack.Top ? -1 : 1;
@@ -52,5 +52,5 @@
 
     public CodeDoRangeExpression(LoopState state) : base(state) { }
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter, interpreter.CodeStack);
     }
@@ -90,5 +90,5 @@
 
     public ExecDoRangeExpression(LoopState state) : base(state) { }
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter, interpreter.ExecStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 14733)
@@ -7,9 +7,9 @@
     protected DoTimesExpression() { }
     protected DoTimesExpression(LoopState state) : base(state) { }
-    protected override bool HasInsufficientArguments(IPushGpInterpreter interpreter, IStack<Expression> sourceStack) {
+    protected override bool HasInsufficientArguments(IPushInterpreter interpreter, IStack<Expression> sourceStack) {
       return (interpreter.IntegerStack.Count < 1) || (sourceStack.Count == 0) || (interpreter.IntegerStack.Top <= 0);
     }
 
-    protected override LoopState InitState(IPushGpInterpreter interpreter, IStack<Expression> sourceStack) {
+    protected override LoopState InitState(IPushInterpreter interpreter, IStack<Expression> sourceStack) {
       //this.State.Body = sourceStack.Pop();
       //this.State.DestinationIndex = interpreter.IntegerStack.Pop();
@@ -24,5 +24,5 @@
     }
 
-    protected override void PushIteration(IPushGpInterpreter interpreter) {
+    protected override void PushIteration(IPushInterpreter interpreter) {
       var newState = new LoopState(State.Body, State.CurrentIndex + this.State.Incrementor, State.DestinationIndex, State.Incrementor);
       var nextLoopExpression = Clone(newState);
@@ -31,5 +31,5 @@
     }
 
-    protected override void PushLastIteration(IPushGpInterpreter interpreter) {
+    protected override void PushLastIteration(IPushInterpreter interpreter) {
       interpreter.ExecStack.Push(this.State.Body);
     }
@@ -47,5 +47,5 @@
     public CodeDoTimesExpression(LoopState state) : base(state) { }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter, interpreter.CodeStack);
     }
@@ -70,5 +70,5 @@
     public ExecDoTimesExpression(LoopState state) : base(state) { }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter, interpreter.ExecStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 14733)
@@ -27,5 +27,5 @@
   [PushExpression(StackType.Integer, "INTEGER.DUP")]
   public class IntegerDuplicateExpression : DuplicateExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack);
     }
@@ -34,5 +34,5 @@
   [PushExpression(StackType.Float, "FLOAT.DUP")]
   public class FloatDuplicateExpression : DuplicateExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack);
     }
@@ -41,5 +41,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.DUP")]
   public class BooleanDuplicateExpression : DuplicateExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.BooleanStack);
     }
@@ -48,5 +48,5 @@
   [PushExpression(StackType.Name, "NAME.DUP")]
   public class NameDuplicateExpression : DuplicateExpression<string> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.NameStack);
     }
@@ -55,5 +55,5 @@
   [PushExpression(StackType.Exec, "EXEC.DUP")]
   public class ExecDuplicateExpression : DuplicateExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.ExecStack);
     }
@@ -62,5 +62,5 @@
   [PushExpression(StackType.Code, "CODE.DUP")]
   public class CodeDuplicateExpression : DuplicateExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.CodeStack);
     }
